/*------------------------------------------------------------------------------
    インクルード
------------------------------------------------------------------------------*/
#define API_CPP
#include "common.h"

/*------------------------------------------------------------------------------
    プロトタイプ
------------------------------------------------------------------------------*/
void *IsNull (void *res, LCHAR *);

/* Ｃ */
/*------------------------------------------------------------------------------
    宣言：handleapi.h
    機能：CloseHandle
------------------------------------------------------------------------------*/
BOOL api_CloseHandle(HANDLE v1)
{
	return (BOOL)IsNull((void *)CloseHandle(v1), L"CloseHandle");
}

/*------------------------------------------------------------------------------
    宣言：synchapi.h
    機能：CreateMutex
------------------------------------------------------------------------------*/
HANDLE api_CreateMutex(LPSECURITY_ATTRIBUTES v1, BOOL v2, LPCWSTR v3)
{
	return (HANDLE)IsNull((void *)CreateMutex(v1, v2, v3), L"CreateMutex");
}

/*------------------------------------------------------------------------------
    宣言：shellapi.h
    機能：CommandLineToArgvW
------------------------------------------------------------------------------*/
LPWSTR *api_CommandLineToArgvW(LPCWSTR v1, int *v2)
{
	return (LPWSTR *)IsNull((void *)CommandLineToArgvW(v1, v2), L"CommandLineToArgvW");
}

/* Ｆ */
/*------------------------------------------------------------------------------
    宣言：winuser.h
    機能：FindWindow
------------------------------------------------------------------------------*/
HWND api_FindWindow(LPCWSTR v1, LPCWSTR v2)
{
	return FindWindow(v1, v2);
}

/* Ｇ */
/*------------------------------------------------------------------------------
    宣言：libloaderapi.h
    機能：GetModuleFileName
------------------------------------------------------------------------------*/
Status api_GdiplusStartup(ULONG_PTR *v1, const GdiplusStartupInput *v2, GdiplusStartupOutput *v3)
{
	Status res = GdiplusStartup(v1, v2, v3);
	
	if (res != Ok) {
		MessageBox(NULL, L"danger GdiplusStartup", L_FATAL, MB_OK);
		exit(1);
	}
	
	return res;
}

/*------------------------------------------------------------------------------
    宣言：libloaderapi.h
    機能：GetModuleFileName
------------------------------------------------------------------------------*/
DWORD api_GetModuleFileName(HMODULE v1, LPWSTR v2, DWORD v3)
{
	return (DWORD)IsNull((void *)GetModuleFileName(v1, v2, v3), L"GetModuleFileName");
}

/* Ｍ */
/*------------------------------------------------------------------------------
    宣言：winuser.h
    機能：MessageBox
------------------------------------------------------------------------------*/
int api_MessageBox(HWND v1, LPCWSTR v2, LPCWSTR v3, UINT v4)
{
	return (DWORD)IsNull((void *)MessageBox(v1, v2, v3, v4), L"MessageBox");
}

/* Ｏ */
/*------------------------------------------------------------------------------
    宣言：synchapi.h
    機能：OpenMutex
------------------------------------------------------------------------------*/
HANDLE api_OpenMutex(DWORD v1, BOOL v2, LPCWSTR v3)
{
	return (HANDLE)IsNull((void *)OpenMutex(v1, v2, v3), L"OpenMutex");
}

/* Ｐ */
/*------------------------------------------------------------------------------
    宣言：shlwapi.h
    機能：PathRemoveFileSpec
------------------------------------------------------------------------------*/
BOOL api_PathRemoveFileSpec(LPWSTR v1)
{
	return PathRemoveFileSpec(v1);
}

/* Ｒ */
/*------------------------------------------------------------------------------
    宣言：synchapi.h
    機能：ReleaseMutex
------------------------------------------------------------------------------*/
BOOL api_ReleaseMutex(HANDLE v1)
{
	return (BOOL)IsNull((void *)ReleaseMutex(v1), L"ReleaseMutex");
}

/* Ｓ */
/*------------------------------------------------------------------------------
    宣言：winbase.h
    機能：SetCurrentDirectory
------------------------------------------------------------------------------*/
BOOL api_SetCurrentDirectory(LPCTSTR v1)
{
	return (BOOL)IsNull((void *)SetCurrentDirectory(v1), L"SetCurrentDirectory");
}

/*------------------------------------------------------------------------------
    宣言：winuser.h
    機能：SetForegroundWindow
------------------------------------------------------------------------------*/
BOOL api_SetForegroundWindow(HWND v1)
{
	return SetForegroundWindow(v1);
}

/*------------------------------------------------------------------------------
    宣言：winuser.h
    機能：SetWindowText
------------------------------------------------------------------------------*/
BOOL api_SetWindowText(HWND v1, LPCWSTR v2)
{
	return (BOOL)IsNull((void *)SetWindowText(v1, v2), L"SetWindowText");
}

/* Ｗ */
/*------------------------------------------------------------------------------
    宣言：synchapi.h
    機能：WaitForSingleObject
------------------------------------------------------------------------------*/
DWORD api_WaitForSingleObject(HANDLE v1, DWORD v2)
{
	DWORD res = WaitForSingleObject(v1, v2);
	
	if (res == WAIT_FAILED) {
		MessageBox(NULL, L"danger WaitForSingleObject", L_FATAL, MB_OK);
		exit(1);
	}
	
	return res;
}

/*------------------------------------------------------------------------------
    宣言：string.h wchar.h
    機能：wcscpy
------------------------------------------------------------------------------*/
wchar_t *api_wcscpy(wchar_t *v1, const wchar_t *v2)
{
	return (wchar_t *)IsNull((void *)wcscpy(v1, v2), L"api_wcscpy");
}

/*------------------------------------------------------------------------------
    宣言：string.h wchar.h
    機能：wcslen
------------------------------------------------------------------------------*/
size_t api_wcslen(const wchar_t *v1)
{
	return wcslen(v1);
}

/*------------------------------------------------------------------------------
    宣言：wchar.h
    機能：wmemset
------------------------------------------------------------------------------*/
wchar_t *api_wmemset(wchar_t *v1, wchar_t v2, size_t v3)
{
	return wmemset(v1, v2, v3);
}

/*------------------------------------------------------------------------------
    書式：void *IsNull(void *, LCHAR *)
    引数：void *   -
          LCHAR *  -
    機能：結果がヌルならエラーで終了
------------------------------------------------------------------------------*/
void *IsNull(void *res, LCHAR *pStr)
{
	WCHAR buff[100];
	DWORD err;
	
	if (res == NULL) {
		err = GetLastError();
		swprintf(buff, L"danger %s 0x%08X", pStr, err);
		MessageBox(NULL, buff, L_FATAL, MB_OK);
		exit(1);
	}
	return res;
}
