// １日いくら

/*------------------------------------------------------------------------------
	インクルード
------------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdarg.h>

/*------------------------------------------------------------------------------
	デファイン
------------------------------------------------------------------------------*/
#define TRUE        1
#define FALSE       0
#define BRAND       30
#define MAXCNT      500

#define CNT         198
#define OUTS        18
#define DAYS        21
#define YEAR        24
#define MONTH       5
#define MONTHBLANK  3
#define DAY         31
#define HOLYDAY1    3
#define HOLYDAY2    4
#define HOLYDAY3    5
#define HOLYDAY4    6
#define HOLYDAY5    -1

// #define CNT         180
// #define OUTS        21
// #define DAYS        21
// #define YEAR        24
// #define MONTH       4
// #define MONTHBLANK  1
// #define DAY         30
// #define HOLYDAY1    29
// #define HOLYDAY2    -1
// #define HOLYDAY3    -1
// #define HOLYDAY4    -1
// #define HOLYDAY5    -1

/*------------------------------------------------------------------------------
	枠
------------------------------------------------------------------------------*/
#define X1          77
#define Y1          255
#define X2          767
#define Y2          863
#define tX1         77
#define tY1         910
#define tX2         767
#define tY2         1030

/*------------------------------------------------------------------------------
	列挙
------------------------------------------------------------------------------*/
enum {
	N0000,  // 日経平均
	I1605,  // INPEX
	V2656,  // ベクターホールディングス
	S3778,  // さくらインターネット
	L4689,  // LINEヤフー
	E5020,  // ENEOS
	A5032,  // ANYCOLOR
	C5253,  // カバー
	S6460,  // セガサミーホールディングス
	R6723,  // ルネサスエレクトロニクス
	S6758,  // ソニーグループ
	M7011,  // 三菱重工業
	N7201,  // 日産自動車
	T7203,  // トヨタ自動車
	M7261,  // マツダ
	H7267,  // 本田技研工業
	K7494,  // コナカ
	O7647,  // 音通
	P7956,  // ピジョン
	M8306,  // 三菱UFJフィナンシャル・グループ
	R8308,  // りそなホールディングス
	M8316,  // 三井住友フィナンシャルグループ
	S8410,  // セブン銀行
	M8411,  // みずほフィナンシャルグループ
	N9432,  // 日本電信電話
	K9973,  // 小僧寿し
};

/*------------------------------------------------------------------------------
	マクロ
------------------------------------------------------------------------------*/
#define PRINT(x, ...)  fprintf_crlf((char *)x, ##__VA_ARGS__)

/*------------------------------------------------------------------------------
	型定義
------------------------------------------------------------------------------*/
typedef char      INT8;
typedef int       INT32;
typedef long long INT64;
typedef int       BOOL;

/*------------------------------------------------------------------------------
	構造体
------------------------------------------------------------------------------*/
typedef struct Field {
	INT32  date;
	double sta;
	double max;
	double min;
	double end;
	double ratio;
	double trade;
} Field;

struct {
	INT32 max;
	INT32 min;
	INT32 range;
	INT32 tMax;
	INT32 tMin;
	double tRange;
	INT32 step1;
	INT32 step2;
	double divi;
	INT32 xScale;
	INT32 tXScale;
	char str[5][100+1];
} params[BRAND] = {
	{41000, 35000, 6000, 300000, 0, 3000000000, 500, 1000, 0, 20, 15,
	 {"0000 日経平均",
	  "",
	  "",
	  "",
	  "",},
	},
	{2650, 2150, 500, 3000, 0, 30000000, 25, 50, 74, 20, 10,
	 {"1605 INPEX",
	  "東証プライム",
	  "",
	  "37円　2023年6月末",
	  "37円　2023年12月末",},
	},
//	 180, 110, 70, 900, 0, 9000000, 5, 10, 0, 20, 10,
	{180, 110, 70, 450, 0, 4500000, 5, 10, 0, 20, 10,
	 {"2656 ベクターホールディングス",
	  "東証スタンダード",
	  "",
	  "",
	  "",},
	},
	{9000, 3000, 6000, 1500, 0, 15000000, 250,500, 7, 20, 10,
	 {"3778 さくらインターネット",
	  "東証プライム",
	  "",
	  "3.5円　2023年 9月末",
	  "3.5円　2024年 3月末",},
	},
	{400, 330, 70, 3900, 0, 39000000, 5,10, 5.56, 20, 10,
	 {"4689 LINEヤフー",
	  "東証プライム",
	  "TOPIX Large70",
	  "5.56円　2023年 3月末",
	  "5.56円　2024年 3月末",},
	},
	{825, 675, 150, 6000, 0, 60000000, 5, 25, 22, 20, 10,
	 {"5020 ENEOS",
	  "東証プライム",
	  "TOPIX Large70",
	  "11円　2023年9月末",
	  "11円　2024年3月末",},
	},
	{3100, 2000, 1100, 300, 0, 3000000, 50, 100, 0, 20, 10,
	 {"5032 ANYCOLOR",
	  "東証プライム",
	  "",
	  "",
	  "",},
	},
//	 2400, 1600, 800, 600, 0, 6000000, 50, 100, 0, 20, 10,
	{2300, 1500, 800, 1500, 0, 15000000, 50, 100, 0, 20, 10,
	 {"5253 カバー",
	  "東証グロース",
	  "",
	  "",
	  "",},
	},
//	 2200, 1700, 500, 300, 0, 3000000, 50, 100, 50, 20, 10,
	{2400, 1900, 500, 420, 0, 4200000, 50, 100, 50, 20, 10,
	 {"6460 セガサミーホールディングス",
	  "東証プライム",
	  "",
	  "23円　2023年 9月末",
	  "27円　2024年 3月末",},
	},
//	{3000, 2200, 800, 3000, 0, 30000000, 50, 100, 28, 20, 10,
	{3100, 2300, 800, 3000, 0, 30000000, 50, 100, 28, 20, 10,
	 {"6723 ルネサスエレクトロニクス",
	  "東証プライム",
	  "TOPIX Large70",
	  "28円　2023年12月末",
	  "",},
	},
	{14000, 11000, 3000, 900, 0, 9000000, 500, 1000, 85, 10, 10,
	 {"6758 ソニーグループ",
	  "東証プライム",
	  "TOPIX Core30",
	  "40円　2023年 9月末",
	  "45円　2024年 3月末",},
	},
	{1500, 1000, 500, 9000, 0, 90000000, 50, 100, 20, 20, 10,
	 {"7011 三菱重工業",
	  "東証プライム",
	  "TOPIX Large70",
	  " 8円　2023年 9月末",
	  "12円　2024年 3月末",},
	},
	{675, 500, 175, 9000, 0, 90000000, 5, 25, 20, 20, 10,
	 {"7201 日産自動車",
	  "東証プライム",
	  "TOPIX Large70",
	  " 5円　2023年 9月末",
	  "15円　2024年 3月末",},
	},
	{3900, 3300, 600, 4200, 0, 42000000, 50, 100, 75, 20, 10,
	 {"7203 トヨタ自動車",
	  "東証プライム",
	  "TOPIX Core30",
	  "30円　2023年 9月末",
	  "45円　2024年 3月末",},
	},
	{1900, 1500, 400, 1200, 0, 12000000, 50, 100, 60, 20, 10,
	 {"7261 マツダ",
	  "東証プライム",
	  "TOPIX Mid400",
	  "25円　2023年 9月末",
	  "35円　2024年 3月末",},
	},
	{2000, 1500, 500, 2100, 0, 21000000, 50, 100, 68, 20, 10,
	 {"7267 本田技研工業",
	  "東証プライム",
	  "TOPIX Core30",
	  "29円　2023年 9月末",
	  "39円　2024年 3月末",},
	},
//	 430, 380, 50, 15, 0, 150000, 5, 10, 0, 20, 10,
	{430, 290, 140, 150, 0, 1500000, 5, 10, 0, 20, 10,
	 {"7494 コナカ",
	  "東証スタンダード",
	  "",
	  "10円　2023年 9月末",
	  "10円　2024年 3月末",},
	},
	{35, 20, 15, 30000, 0, 300000000, 1, 5, 0.24, 20, 10,
	 {"7647 音通",
	  "東証スタンダード",
	  "",
	  "0.12円　2023年 9月末",
	  "0.12円　2024年 3月末",},
	},
	{1600, 1300, 300, 300, 0, 3000000, 50, 100, 76, 20, 10,
	 {"7956 ピジョン",
	  "東証プライム",
	  "",
	  "38円　2023年 6月末",
	  "38円　2023年12月末",},
	},
	{1700, 1400, 300, 9900, 0, 99000000, 50, 100, 41, 20, 10,
	 {"8306 三菱UFJフィナンシャル・グループ",
	  "東証プライム",
	  "TOPIX Core30",
	  "20.5円　2023年9月末",
	  "20.5円　2024年3月末",},
	},
	{1200, 800,400, 1800, 0, 18000000, 50, 100, 22, 20, 10,
	 {"8308 りそなホールディングス",
	  "東証プライム",
	  "TOPIX Large70",
	  "11円　2023年9月末",
	  "11円　2024年3月末",},
	},
	{11000, 7000, 4000, 1200, 0, 12000000, 500, 1000, 270, 20, 10,
	 {"8316 三井住友フィナンシャルグループ",
	  "東証プライム",
	  "TOPIX Core30",
	  "135円　2023年9月末",
	  "135円　2024年3月末",},
	},
	{325, 250, 75, 1500, 0, 15000000, 5, 25, 11, 20, 10,
	 {"8410 セブン銀行",
	  "東証プライム",
	  "",
	  "5.5円　2023年9月末",
	  "5.5円　2024年3月末",},
	},
	{3300, 2800, 500, 1500, 0, 15000000, 50, 100, 105, 20, 10,
	 {"8411 みずほフィナンシャルグループ",
	  "東証プライム",
	  "TOPIX Core30",
	  "50円　2023年9月末",
	  "55円　2024年3月末",},
	},
//	 200, 160, 40, 30000, 0, 300000000, 5, 10, 5, 20, 10,
	{190, 150, 40, 36000, 0, 360000000, 1, 10, 5, 20, 10,
	 {"9432 日本電信電話",
	  "東証プライム",
	  "TOPIX Core30",
	  "2.5円　2023年9月末",
	  "2.5円　2024年3月末",},
	},
//	 30, 15, 15, 120, 0, 1200000, 1, 5, 0, 20, 10,
	{30, 15, 15, 1200, 0, 12000000, 1, 5, 0, 20, 10,
	 {"9973 小僧寿し",
	  "東証スタンダード",
	  "",
	  "優待　2022年 9月末",
	  "優待　2023年12月末",},
	},
};

/*------------------------------------------------------------------------------
	株価データ
------------------------------------------------------------------------------*/
#include "field_0000.h"
#include "field_1605.h"
#include "field_2656.h"
#include "field_3778.h"
#include "field_4689.h"
#include "field_5020.h"
#include "field_5032.h"
#include "field_5253.h"
#include "field_6460.h"
#include "field_6723.h"
#include "field_6758.h"
#include "field_7011.h"
#include "field_7201.h"
#include "field_7203.h"
#include "field_7261.h"
#include "field_7267.h"
#include "field_7494.h"
#include "field_7647.h"
#include "field_7956.h"
#include "field_8306.h"
#include "field_8308.h"
#include "field_8316.h"
#include "field_8410.h"
#include "field_8411.h"
#include "field_9432.h"
#include "field_9973.h"

/*------------------------------------------------------------------------------
	ローカル変数
------------------------------------------------------------------------------*/
FILE *fp;
Field *pField;
double ave5 [CNT];
double ave25[CNT];
double ave75[CNT];
double ave100[CNT];
Field tmp[CNT];

/*------------------------------------------------------------------------------
	プロトタイプ
------------------------------------------------------------------------------*/
int main(void);
void execute0(INT32);
void execute1(INT32);
void execute2(INT32);
void execute3(INT32);
void clear(void);
void color(void);
void definition(INT32);
void coordinate(INT32);
void sort(INT32);
void graph(INT32);
void today0(INT32);
void today1(INT32);
void achievement1(INT32);
void achievement2(INT32);
void footer(INT32);
void hit(INT32);
void scale(INT32);
void dividend(INT32);
void calendar(INT32);
void etc(INT32);
BOOL isExist(INT32, INT32, double *);
INT32 convDecToHex(INT32);
void fprintf_crlf(char *pStr, ...);

/*------------------------------------------------------------------------------
	書式：int main(void)
	引数：-
	戻値：int  -
	機能：スタートアップ
------------------------------------------------------------------------------*/
int main(void)
{
	INT8 buff[100];
	
	sprintf(buff, "%04d_20%02d%02d.csv", 0000, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_0000;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute0(N0000);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 1605, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_1605;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(I1605);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 2656, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_2656;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute3(V2656);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 3778, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_3778;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(S3778);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 4689, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_4689;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(L4689);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 5020, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_5020;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(E5020);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 5032, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_5032;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute3(A5032);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 5253, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_5253;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute3(C5253);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 6460, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_6460;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(S6460);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 6723, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_6723;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(R6723);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 6758, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_6758;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(S6758);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 7011, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_7011;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(M7011);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 7201, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_7201;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(N7201);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 7203, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_7203;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(T7203);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 7261, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_7261;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(M7261);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 7267, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_7267;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(H7267);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 7494, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_7494;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(K7494);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 7647, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_7647;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(O7647);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 7956, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_7956;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(P7956);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 8306, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_8306;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(M8306);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 8308, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_8308;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(R8308);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 8316, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_8316;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(M8316);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 8410, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_8410;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(S8410);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 8411, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_8411;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(M8411);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 9432, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_9432;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute1(N9432);
	fclose(fp);
	
	sprintf(buff, "%04d_20%02d%02d.csv", 9973, YEAR, MONTH);
	fp = fopen(buff, "wb");
	pField = field_9973;
	if (fp == NULL) {printf("open error\r\n"); return 1;}
	execute2(K9973);
	fclose(fp);
}

/*------------------------------------------------------------------------------
	書式：void execute0(INT32)
	引数：INT32    -
	機能：実行
------------------------------------------------------------------------------*/
void execute0(INT32 idx)
{
	clear();
	color();
	definition(idx);
	coordinate(idx);
	sort(idx);
	graph(idx);
	today0(idx);
	footer(idx);
	scale(idx);
	calendar(idx);
	etc(idx);
}

/*------------------------------------------------------------------------------
	書式：void execute1(INT32)
	引数：INT32    -
	機能：実行
------------------------------------------------------------------------------*/
void execute1(INT32 idx)
{
	clear();
	color();
	definition(idx);
	coordinate(idx);
	sort(idx);
	graph(idx);
	today1(idx);
	achievement1(idx);
	footer(idx);
	hit(idx);
	scale(idx);
	dividend(idx);
	calendar(idx);
	etc(idx);
}

/*------------------------------------------------------------------------------
	書式：void execute2(INT32)
	引数：INT32    -
	機能：実績
------------------------------------------------------------------------------*/
void execute2(INT32 idx)
{
	clear();
	color();
	definition(idx);
	coordinate(idx);
	sort(idx);
	graph(idx);
	today1(idx);
	achievement2(idx);
	footer(idx);
	hit(idx);
	scale(idx);
	calendar(idx);
	etc(idx);
}

/*------------------------------------------------------------------------------
	書式：void execute3(INT32)
	引数：INT32    -
	機能：実績
------------------------------------------------------------------------------*/
void execute3(INT32 idx)
{
	clear();
	color();
	definition(idx);
	coordinate(idx);
	sort(idx);
	graph(idx);
	today1(idx);
	footer(idx);
	hit(idx);
	scale(idx);
	calendar(idx);
	etc(idx);
}

/*------------------------------------------------------------------------------
	書式：void claer(void)
	機能：塗りつぶす
------------------------------------------------------------------------------*/
void clear(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  塗りつぶし");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("RECT, 0, 0, 840, 1050, 000000, FFFFFF, 0, 0, FALSE, TRUE, FALSE, FALSE");
	
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void color(void)
	機能：色
------------------------------------------------------------------------------*/
void color(void)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  色");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, RGB_BLACK,  000000");
	PRINT("DEFINE, RGB_GRAY,   C0C0C0");
	PRINT("DEFINE, RGB_RED,    F00000");
	PRINT("DEFINE, RGB_GREEN,  00F000");
	PRINT("DEFINE, RGB_BLUE,   0000F0");
	PRINT("DEFINE, RGB_MAZENTA,F000F0");
	PRINT("DEFINE, RGB_YELLOW, F0F000");
	PRINT("DEFINE, RGB_CYAN,   00F0F0");
	PRINT("DEFINE, RGB_AVE100, F0F0F0");
	PRINT("DEFINE, RGB_AVE75,  A0A0F0");
	PRINT("DEFINE, RGB_AVE25,  F0A0A0");
	PRINT("DEFINE, RGB_AVE5,   A0F0A0");
	
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void definition(INT32)
	引数：INT32    -
	機能：定義
------------------------------------------------------------------------------*/
void definition(INT32 idx)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  定義");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, DAYS,       %d", DAYS);
	PRINT("DEFINE, MAX,        %d", params[idx].max);
	PRINT("DEFINE, MIN,        %d", params[idx].min);
	PRINT("DEFINE, RANGE,      %d", params[idx].range);
	
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void coordinate(INT32)
	引数：INT32    -
	機能：座標
------------------------------------------------------------------------------*/
void coordinate(INT32 idx)
{
	INT32 i;
	INT32 cnt;
	INT8 fmt[100+1] = "DEFINE, tY_%04d,    (((tH*%d)/6)+tY1)";
	
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  座標");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, X1,         %d", X1);
	PRINT("DEFINE, Y1,         %d", Y1);
	PRINT("DEFINE, X2,         %d", X2);
	PRINT("DEFINE, Y2,         %d", Y2);
	PRINT("DEFINE, W,          (X2-X1)");
	PRINT("DEFINE, H,          (Y2-Y1)");
	PRINT("DEFINE, X_SCALE,    %d", params[idx].xScale);
	PRINT("DEFINE, Y_WEEKEND,  (Y2+5)");
	
	cnt = (params[idx].max - params[idx].min) / params[idx].step1;
	for (i = 0; i <= cnt; i++) {
		PRINT("DEFINE, Y_%d,      (((H*%2d)/%d)+Y1)",  params[idx].max - params[idx].step1 * i, i, cnt);
	}
	
	PRINT("DEFINE, gX,         (X1+18)");
	PRINT("DEFINE, gW,         (W-18*2)");
	PRINT("DEFINE, tX1,        %d", tX1);
	PRINT("DEFINE, tY1,        %d", tY1);
	PRINT("DEFINE, tX2,        %d", tX2);
	PRINT("DEFINE, tY2,        %d", tY2);
	PRINT("DEFINE, tW,         W");
	PRINT("DEFINE, tH,         (tY2-tY1)");
	PRINT("DEFINE, tMAX,       %d", params[idx].tMax);
	PRINT("DEFINE, tMIN,       %d", params[idx].tMin);
	PRINT("DEFINE, tRANGE,     %.0f", params[idx].tRange);
	PRINT("DEFINE, tX_SCALE,   %d", params[idx].tXScale);
	
	for (i = 0; i < 7; i++) {
		PRINT(fmt, (INT32)((params[idx].tRange / 10000) - ((params[idx].tRange / 10000) / 6) * i), i);
	}
	
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void sort(INT32)
	引数：INT32    -
	機能：並び替え
------------------------------------------------------------------------------*/
void sort(INT32 idx)
{
	INT32 i, j;
	INT32 deno;
	
	for (i = 0; i < CNT; i++) {tmp[i] = pField[CNT-1-i];}
	
	for (i = 0; i < CNT; i++) {
		ave5 [i]  = 0.0;
		ave25[i]  = 0.0;
		ave75[i]  = 0.0;
		ave100[i] = 0.0;
		
		if (4 <= i) {
			for (j = 0; j < 5; j++) {
				ave5[i] += tmp[i-j].end;
			}
			ave5[i] /= 5;
		}
		else {
			deno = i+1;
			for (j = 0; j < deno; j++) {
				ave5[i] += tmp[i-j].end;
			}
			ave5[i] /= deno;
		}
		
		if (24 <= i) {
			for (j = 0; j < 25; j++) {
				ave25[i] += tmp[i-j].end;
			}
			ave25[i] /= 25;
		}
		else {
			deno = i+1;
			for (j = 0; j < deno; j++) {
				ave25[i] += tmp[i-j].end;
			}
			ave25[i] /= deno;
		}
		
		if (74 <= i) {
			for (j = 0; j < 75; j++) {
				ave75[i] += tmp[i-j].end;
			}
			ave75[i] /= 75;
		}
		else {
			deno = i+1;
			for (j = 0; j < deno; j++) {
				ave75[i] += tmp[i-j].end;
			}
			ave75[i] /= deno;
		}
		
		if (99 <= i) {
			for (j = 0; j < 100; j++) {
				ave100[i] += tmp[i-j].end;
			}
			ave100[i] /= 100;
		}
		else {
			deno = i+1;
			for (j = 0; j < deno; j++) {
				ave100[i] += tmp[i-j].end;
			}
			ave100[i] /= deno;
		}
	}
}

/*------------------------------------------------------------------------------
	書式：void graph(INT32)
	引数：INT32    -
	機能：グラフ
------------------------------------------------------------------------------*/
void graph(INT32 idx)
{
	INT32 i;
	INT8 fmt1[150+1] = "MOVETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f-MIN))/RANGE), %s";
	INT8 fmt2[150+1] = "LINETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f-MIN))/RANGE)";
	INT8 fmt3[150+1] = "DEFINE, GY%02X_%s, (Y2-((H*(%.1f-MIN))/RANGE))";
	INT8 fmt4[150+1] = "DEFINE, GH%02X,     ((H*(%.1f-%.1f))/RANGE)";
	INT8 fmt5[150+1] = "DEFINE, GH%02X,     %d";
	INT8 fmt6[150+1] = "RECT, X1+(W*%2d)/(DAYS+1), GY%02X_%s, 7, GH%02X, 000000, %s 1, 0, FALSE, TRUE, FALSE, FALSE";
	INT8 fmt7[150+1] = "LINE, X1+(W*%2d)/(DAYS+1)+3, GY%02X_MAX, X1+(W*%2d)/(DAYS+1)+3, GY%02X_MIN, %s 1";
	INT8 fmt8[150+1] = "MOVETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f%+.1f* 1-MIN))/RANGE), %s";
	INT8 fmt9[150+1] = "LINETO, X1+(W*%2d)/(DAYS+1), Y2-((H*(%.1f%+.1f*%2d-MIN))/RANGE)";
	INT32 dt;
	
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  グラフ");
	PRINT(":-------------------------------------------------------------------------------");
	
	for (i = 0; (params[idx].min + params[idx].step2 * i) <= params[idx].max; i++) {
		PRINT("LINE, X1+1, Y_%d, X2-1, Y_%d, RGB_GRAY, 1", params[idx].min+params[idx].step2 * i,
														   params[idx].min+params[idx].step2 * i);
	}
	PRINT("");
	
	for (i = 0; (params[idx].min + params[idx].step1 * i) <= params[idx].max; i++) {
		PRINT("LINE, X1, Y_%d, X1+4, Y_%d, RGB_BLACK, 1", params[idx].min + params[idx].step1 * i,
														  params[idx].min + params[idx].step1 * i);
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUTS) <= i) {
			if (i == (CNT - OUTS)) {
				PRINT(fmt1, i-(CNT - OUTS)+1, ave100[i], "RGB_AVE100, 7");
			}
			else {
				PRINT(fmt2, i-(CNT - OUTS)+1, ave100[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUTS) <= i) {
			if (i == (CNT - OUTS)) {
				PRINT(fmt1, i-(CNT - OUTS)+1, ave75[i], "RGB_AVE75, 2");
			}
			else {
				PRINT(fmt2, i-(CNT - OUTS)+1, ave75[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUTS) <= i) {
			if (i == (CNT - OUTS)) {
				PRINT(fmt1, i-(CNT - OUTS)+1, ave25[i], "RGB_AVE25, 2");
			}
			else {
				PRINT(fmt2, i-(CNT - OUTS)+1, ave25[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUTS) <= i) {
			if (i == (CNT - OUTS)) {
				PRINT(fmt1, i-(CNT - OUTS)+1, ave5[i], "RGB_AVE5, 2");
			}
			else {
				PRINT(fmt2, i-(CNT - OUTS)+1, ave5[i]);
			}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUTS) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			PRINT(fmt3, dt, "STA", tmp[i].sta);
			PRINT(fmt3, dt, "MAX", tmp[i].max);
			PRINT(fmt3, dt, "MIN", tmp[i].min);
			PRINT(fmt3, dt, "END", tmp[i].end);
			
			if (tmp[i].end >= tmp[i].sta) {
				if ((INT32)((608*(tmp[i].end-tmp[i].sta))/params[idx].range) == 0) {
					PRINT(fmt5, dt, 1);
				}
				else {
					PRINT(fmt4, dt, tmp[i].end, tmp[i].sta);
				}
			}
			else {
				if ((INT32)((608*(tmp[i].sta-tmp[i].end))/params[idx].range) == 0) {
					PRINT(fmt5, dt, 1);
				}
				else {
					PRINT(fmt4, dt, tmp[i].sta, tmp[i].end);
				}
			}
			PRINT("");
		}
	}
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUTS) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			if (tmp[i].end >= tmp[i].sta) {PRINT(fmt6, i-(CNT - OUTS)+1, dt, "END", dt, "RGB_RED, ");}
			else                          {PRINT(fmt6, i-(CNT - OUTS)+1, dt, "STA", dt, "RGB_BLUE,");}
		}
	}
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUTS) <= i) {
			dt = tmp[i].date & 0x000000FF;
			
			if (tmp[i].end >= tmp[i].sta) {PRINT(fmt7, i-(CNT-OUTS)+1, dt, i-(CNT-OUTS)+1, dt, "RGB_RED, ");}
			else                          {PRINT(fmt7, i-(CNT-OUTS)+1, dt, i-(CNT-OUTS)+1, dt, "RGB_BLUE,");}
		}
	}
	PRINT("");
	
	if ((OUTS+1) < DAYS) {
		PRINT(fmt8, OUTS+1, ave100[CNT-1], ave100[CNT-1]-ave100[CNT-2], "RGB_AVE100, 7");
		PRINT(fmt9, DAYS,   ave100[CNT-1], ave100[CNT-1]-ave100[CNT-2], DAYS-OUTS);
		PRINT("");
		PRINT(fmt8, OUTS+1, ave75[CNT-1], ave75[CNT-1]-ave75[CNT-2], "RGB_AVE75, 2");
		PRINT(fmt9, DAYS,   ave75[CNT-1], ave75[CNT-1]-ave75[CNT-2], DAYS-OUTS);
		PRINT("");
		PRINT(fmt8, OUTS+1, ave25[CNT-1], ave25[CNT-1]-ave25[CNT-2], "RGB_AVE25, 2");
		PRINT(fmt9, DAYS,   ave25[CNT-1], ave25[CNT-1]-ave25[CNT-2], DAYS-OUTS);
		PRINT("");
		PRINT(fmt8, OUTS+1, ave5[CNT-1], ave5[CNT-1]-ave5[CNT-2], "RGB_AVE5, 2");
		PRINT(fmt9, DAYS,   ave5[CNT-1], ave5[CNT-1]-ave5[CNT-2], DAYS-OUTS);
		
		PRINT("");
	}
	
	PRINT("RECT, 0,   0,   840,     Y1,       000000, FFFFFF, 0, 0, FALSE, TRUE, FALSE, FALSE");
	PRINT("RECT, 0,   Y2+1,840,     1050-Y2-1,000000, FFFFFF, 0, 0, FALSE, TRUE, FALSE, FALSE");
	PRINT("RECT, 0,   0,   X1,      1050,     000000, FFFFFF, 0, 0, FALSE, TRUE, FALSE, FALSE");
	PRINT("RECT, X2+1,0,   840-X2-1,1050,     000000, FFFFFF, 0, 0, FALSE, TRUE, FALSE, FALSE");
	PRINT("");
	PRINT("LINE, X1, Y1, X2, Y1, RGB_BLACK, 1");
	PRINT("LINE, X1, Y1, X1, Y2, RGB_BLACK, 1");
	PRINT("LINE, X2, Y1, X2, Y2, RGB_BLACK, 1");
	PRINT("LINE, X1, Y2, X2, Y2, RGB_BLACK, 1");
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void today0(INT32)
	引数：INT32    -
	機能：今日
------------------------------------------------------------------------------*/
void today0(INT32 idx)
{
	char buff[100+1];
	char fmt1[200+1] = "TEXT, 319, 25 ,%-30s RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt2[200+1] = "TEXT, 82,  95 ,%-30s RGB_BLACK, 000000, TRUE, Arial, 50, FALSE";
	char fmt3[200+1] = "TEXT, 75,  152,%-30s RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  今日");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("RECT, 45,  70,  250, 120, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("RECT, 49,  74,  242, 112, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	
	PRINT("");
	
	sprintf(buff, "%s 20%02X年%2X月,", params[idx].str[0], (tmp[CNT-1].date & 0x00FF0000)>>16, 
														   (tmp[CNT-1].date & 0x0000FF00)>> 8);
	PRINT(fmt1, buff);
	
	sprintf(buff, "%.2f,", tmp[CNT-1].end);
	PRINT(fmt2, buff);
	
	sprintf(buff, "20%02X/%02X/%02X 15:00 現在,", (tmp[CNT-1].date & 0x00FF0000)>>16,
												  (tmp[CNT-1].date & 0x0000FF00)>> 8,
												  (tmp[CNT-1].date & 0x000000FF)>> 0);
	PRINT(fmt3, buff);
	
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void today1(INT32)
	引数：INT32    -
	機能：今日
------------------------------------------------------------------------------*/
void today1(INT32 idx)
{
	INT32 x;
	INT8 strBlue   [12+1] = "RGB_BLUE,   ";
	INT8 strRed    [12+1] = "RGB_RED,    ";
	INT8 strGreen  [12+1] = "RGB_GREEN,  ";
	INT8 strMazenta[12+1] = "RGB_MAZENTA,";
	INT8 strCyan   [12+1] = "RGB_CYAN,   ";
	INT8 strYellow [12+1] = "RGB_YELLOW, ";
	INT8 strBlack  [12+1] = "RGB_BLACK,  ";
	INT8 *p1, *p2;
	char buff[100+1];
	char fmt1[200+1] = "TEXT, %d,  25 ,%-30s RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt2[200+1] = "TEXT, 325,  62 ,%-30s, %s000000, TRUE, Arial, 22, FALSE";
	char fmt3[200+1] = "TEXT, 325,  89 ,%-30s, %s000000, TRUE, Arial, 22, FALSE";
	char fmt4[200+1] = "TEXT, %d,  100,%-30s RGB_BLACK, 000000, TRUE, Arial, 70, FALSE";
	char fmt5[200+1] = "TEXT, 75,  185,%-30s RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  今日");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("RECT, 45,  70,  250, 160, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	PRINT("RECT, 49,  74,  242, 152, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	
	PRINT("");
	
	switch (idx) {
	case I1605:  x = 319;  break;
	case V2656:  x = 279;  break;
	case S3778:  x = 279;  break;
	case L4689:  x = 309;  break;
	case E5020:  x = 319;  break;
	case A5032:  x = 309;  break;
	case C5253:  x = 319;  break;
	case S6460:  x = 248;  break;
	case R6723:  x = 255;  break;
	case S6758:  x = 300;  break;
	case M7011:  x = 309;  break;
	case N7201:  x = 300;  break;
	case T7203:  x = 310;  break;
	case M7261:  x = 320;  break;
	case H7267:  x = 300;  break;
	case K7494:  x = 319;  break;
	case O7647:  x = 319;  break;
	case P7956:  x = 319;  break;
	case M8306:  x = 228;  break;
	case R8308:  x = 290;  break;
	case M8316:  x = 245;  break;
	case S8410:  x = 319;  break;
	case M8411:  x = 238;  break;
	case N9432:  x = 319;  break;
	case K9973:  x = 319;  break;
	default:     x = 0;    break;
	}
	
	sprintf(buff, "%s 20%02X年%2X月,", params[idx].str[0], (tmp[CNT-1].date & 0x00FF0000)>>16, 
														   (tmp[CNT-1].date & 0x0000FF00)>> 8);
	PRINT(fmt1, x, buff);
	
	switch (idx) {
	case I1605:  p1 = strBlue;   p2 = strBlack;    break;
	case V2656:  p1 = strRed;    p2 = strBlack;    break;
	case S3778:  p1 = strBlue;   p2 = strBlack;    break;
	case L4689:  p1 = strBlue;   p2 = strCyan;     break;
	case E5020:  p1 = strBlue;   p2 = strCyan;     break;
	case A5032:  p1 = strBlue;   p2 = strBlack;    break;
	case C5253:  p1 = strGreen;  p2 = strBlack;    break;
	case S6460:  p1 = strBlue;   p2 = strBlack;    break;
	case R6723:  p1 = strBlue;   p2 = strCyan;     break;
	case S6758:  p1 = strBlue;   p2 = strMazenta;  break;
	case M7011:  p1 = strBlue;   p2 = strCyan;     break;
	case N7201:  p1 = strBlue;   p2 = strCyan;     break;
	case T7203:  p1 = strBlue;   p2 = strMazenta;  break;
	case M7261:  p1 = strBlue;   p2 = strYellow;   break;
	case H7267:  p1 = strBlue;   p2 = strMazenta;  break;
	case K7494:  p1 = strRed;    p2 = strBlack;    break;
	case O7647:  p1 = strRed;    p2 = strBlack;    break;
	case P7956:  p1 = strBlue;   p2 = strBlack;    break;
	case M8306:  p1 = strBlue;   p2 = strMazenta;  break;
	case R8308:  p1 = strBlue;   p2 = strCyan;     break;
	case M8316:  p1 = strBlue;   p2 = strMazenta;  break;
	case S8410:  p1 = strBlue;   p2 = strBlack;    break;
	case M8411:  p1 = strBlue;   p2 = strMazenta;  break;
	case N9432:  p1 = strBlue;   p2 = strMazenta;  break;
	case K9973:  p1 = strRed;    p2 = strBlack;    break;
	}
	PRINT(fmt2, params[idx].str[1], p1);
	PRINT(fmt3, params[idx].str[2], p2);
	
	switch (idx) {
	case I1605:  x = 75;   break;
	case V2656:  x = 127;  break;
	case S3778:  x = 105;  break;
	case L4689:  x = 95;   break;
	case E5020:  x = 95;   break;
	case A5032:  x = 105;  break;
	case C5253:  x = 105;  break;
	case S6460:  x = 75;   break;
	case R6723:  x = 75;   break;
	case S6758:  x = 80;   break;
	case M7011:  x = 75;   break;
	case N7201:  x = 94;   break;
	case T7203:  x = 75;   break;
	case M7261:  x = 75;   break;
	case H7267:  x = 75;   break;
	case K7494:  x = 127;  break;
	case O7647:  x = 145;  break;
	case P7956:  x = 75;   break;
	case M8306:  x = 75;   break;
	case R8308:  x = 95;   break;
	case M8316:  x = 105;  break;
	case S8410:  x = 95;   break;
	case M8411:  x = 105;  break;
	case N9432:  x = 95;   break;
	case K9973:  x = 145;  break;
	default:     x = 0;    break;
	}
	
	switch (idx) {
	case I1605:
	case L4689:
	case E5020:
	case S6460:
	case R6723:
	case M7011:
	case N7201:
	case T7203:
	case M7261:
	case H7267:
	case P7956:
	case M8306:
	case R8308:
	case S8410:
	case N9432:
		sprintf(buff, "%.1f,", tmp[CNT-1].end);
		break;
	case V2656:
	case S3778:
	case A5032:
	case C5253:
	case S6758:
	case K7494:
	case O7647:
	case M8316:
	case M8411:
	case K9973:
		sprintf(buff, "%.0f,", tmp[CNT-1].end);
	default:
		break;
	}
	
	PRINT(fmt4, x, buff);
	
	sprintf(buff, "20%02X/%02X/%02X 15:00 現在,", (tmp[CNT-1].date & 0x00FF0000)>>16,
												  (tmp[CNT-1].date & 0x0000FF00)>> 8,
												  (tmp[CNT-1].date & 0x000000FF)>> 0);
	PRINT(fmt5, buff);
	
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void achievement1(INT32)
	引数：INT32    -
	機能：実績
------------------------------------------------------------------------------*/
void achievement1(INT32 idx)
{
	INT32 x;
	char buff[100+1];
	char fmt1[200+1] = "TEXT, 333, 130,%-30s RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt2[200+1] = "TEXT, 333, 162,%-30s RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt3[200+1] = "TEXT, 455, 193,%-30s RGB_BLACK, 000000, TRUE, Arial, 30, FALSE";
	
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  実績");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("RECT, 320, 120, 220, 110, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	
	PRINT("");
	
	sprintf(buff, "%s,", params[idx].str[3]);
	PRINT(fmt1, buff);
	
	sprintf(buff, "%s,", params[idx].str[4]);
	PRINT(fmt2, buff);
	
	if (tmp[CNT-1].end == 0) {printf("0 div error\r\n");}
	
	sprintf(buff, "%.2f%%,", (params[idx].divi/tmp[CNT-1].end)*100);
	PRINT(fmt3, buff);
	
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void achievement2(INT32)
	引数：INT32    -
	機能：実績
------------------------------------------------------------------------------*/
void achievement2(INT32 idx)
{
	INT32 x;
	char buff[100+1];
	char fmt1[200+1] = "TEXT, 333, 162,%-30s RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	char fmt2[200+1] = "TEXT, 333, 194,%-30s RGB_BLACK, 000000, TRUE, Arial, 22, FALSE";
	
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  実績");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("RECT, 320, 152, 220, 78, RGB_BLACK, 000000, 1, 0, FALSE, FALSE, FALSE, FALSE");
	
	PRINT("");
	
	sprintf(buff, "%s,", params[idx].str[3]);
	PRINT(fmt1, buff);
	
	sprintf(buff, "%s,", params[idx].str[4]);
	PRINT(fmt2, buff);
	
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void footer(INT32)
	引数：INT32    -
	機能：フッター
------------------------------------------------------------------------------*/
void footer(INT32 idx)
{
	INT32 i;
	INT32 y;
	INT8 fmt1[100+1] = "LINE, X1,   tY_%04d, X2,   tY_%04d, RGB_GRAY, 1";
	INT8 fmt2[100+1] = "LINE, X1,   tY_%04d, X1+4, tY_%04d, RGB_GRAY, 1";
	INT8 fmt3[100+1] = "LINE, X2-4, tY_%04d, X2,   tY_%04d, RGB_GRAY, 1";
	INT8 fmt4[100+1] = "TEXT, tX_SCALE,    (tY_%04d-7),%6d, RGB_BLACK, 000000, TRUE,ＭＳ ゴシック, 16, FALSE";
	INT8 fmt5[150+1] = "RECT, X1+(W*%2d)/(DAYS+1), tY2, 6, -(tH*%10.0f)/tRANGE, 000000, %s 1, 0, FALSE, TRUE, FALSE, FALSE";
	
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  フッター");
	PRINT(":-------------------------------------------------------------------------------");
	
	for (i = 0; i <= 6; i+=2) {
		y = (INT32)((params[idx].tRange / 10000) - ((params[idx].tRange / 10000) / 6) * i);
		PRINT(fmt1, y, y);
	}
	
	for (i = 1; i < 6; i+=2) {
		y = (INT32)((params[idx].tRange / 10000) - ((params[idx].tRange / 10000) / 6) * i);
		PRINT(fmt2, y, y);
	}
	
	for (i = 1; i < 6; i+=2) {
		y = (INT32)((params[idx].tRange / 10000) - ((params[idx].tRange / 10000) / 6) * i);
		PRINT(fmt3, y, y);
	}
	
	PRINT("");
	
	for (i = 0; i <= 6; i+=2) {
		y = (INT32)((params[idx].tRange / 10000) - ((params[idx].tRange / 10000) / 6) * i);
		PRINT(fmt4, y, y);
	}
	
	PRINT("");
	
	for (i = 0; i < CNT; i++) {
		if ((CNT - OUTS) <= i) {
			if (tmp[i].ratio > 0) {
				PRINT(fmt5, i-(CNT - OUTS)+1, tmp[i].trade, "RGB_RED,  ");
			}
			else if (tmp[i].ratio == 0) {
				PRINT(fmt5, i-(CNT - OUTS)+1, tmp[i].trade, "RGB_BLACK,");
			}
			else {
				PRINT(fmt5, i-(CNT - OUTS)+1, tmp[i].trade, "RGB_BLUE, ");
			}
		}
	}
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void hit(INT32)
	引数：INT32    -
	機能：出現率
------------------------------------------------------------------------------*/
void hit(INT32 idx)
{
	INT32 i;
	INT32 rate[100] = {0};
	INT32 pos;
	INT32 max = 0;
	INT8 fmt1[200] = "RECT, 62+6-%d, (Y_%d-%d), %d*2, %d*2, 000000, RGB_BLACK, 1, 0, FALSE, TRUE, TRUE, FALSE";
	INT32 mposi;
	
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  出現率");
	PRINT(":-------------------------------------------------------------------------------");
	
	mposi = params[idx].range / params[idx].step1;
	
	for (i = 0; i < CNT; i++) {
		pos = (tmp[i].end - params[idx].min) / params[idx].step1;
		
		if (pos < 0)     {continue;}
		if (pos > mposi) {continue;}
		
		rate[pos]++;
	}
	
	for (i = 0; i <= mposi; i++) {
		if (rate[i] >max) {max = rate[i];}
	}
	
	for (i = 0; i <= mposi; i++) {
		pos = params[idx].min + i * params[idx].step1;
		
		if (rate[i] == 0) {
		}
		else if (rate[i] <= ((max*1)/5)) {
			PRINT(fmt1, 1, pos, 1, 1, 1);
		}
		else if (rate[i] <= ((max*2)/5)) {
			PRINT(fmt1, 2, pos, 2, 2, 2);
		}
		else if (rate[i] <= ((max*3)/5)) {
			PRINT(fmt1, 3, pos, 3, 3, 3);
		}
		else if (rate[i] <= ((max*4)/5)) {
			PRINT(fmt1, 4, pos, 4, 4, 4);
		}
		else if (rate[i] <= ((max*5)/5)) {
			PRINT(fmt1, 5, pos, 5, 5, 5);
		}
	}
	PRINT("");
	
	INT8 fmt2[150+1] = "TEXT, 642, 35,平均絶対値　%.1f円, RGB_BLACK, 000000, TRUE, Arial, 16, FALSE";
	double aveAbs;
	
	aveAbs = 0.0;
	for (i = 0; i < OUTS; i++) {
		aveAbs+= abs(tmp[CNT-1-i].ratio);
	}
	
	if (OUTS != 0) {
		aveAbs /= OUTS;
		PRINT(fmt2, aveAbs);
	}
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void scale(INT32)
	引数：INT32    -
	機能：目盛り
------------------------------------------------------------------------------*/
void scale(INT32 idx)
{
	INT32 i;
	INT32 step;
	
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  目盛り");
	PRINT(":-------------------------------------------------------------------------------");
	
	if ((idx == O7647) || (idx == K9973)) {step = params[idx].step1;}
	else                                  {step = params[idx].step2;}
	
	for (i = 0; (params[idx].min + step * i) <= params[idx].max; i++) {
		PRINT("TEXT, X_SCALE,(Y_%d-10),%4d, RGB_BLACK, 000000, TRUE,ＭＳ ゴシック, 20, FALSE", params[idx].min + step * i,
																							   params[idx].min + step * i);
	}
	
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void dividend(INT32)
	引数：INT32    -
	機能：配当
------------------------------------------------------------------------------*/
void dividend(INT32 idx)
{
	INT32 i;
	double per;
	double val;
	
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  配当");
	PRINT(":-------------------------------------------------------------------------------");
	
	per = 0.25;
	while (per < 8.00) {
		val = params[idx].divi / (per / 100);
		
		if ((params[idx].min <= val) && (val <= params[idx].max)) {
			PRINT("DEFINE, Y_%.2f, (Y2-((H*(%.2f-MIN))/RANGE))", per, val);
		}
		per += 0.25;
	}
	
	per = 0.25;
	while (per < 8.00) {
		val = params[idx].divi / (per / 100);
		
		if ((params[idx].min <= val) && (val <= params[idx].max)) {
			PRINT("LINE, X2-4, Y_%.2f, X2, Y_%.2f, RGB_BLACK, 1", per, per);
		}
		per += 0.25;
	}
	
	per = 0.25;
	while (per < 8.00) {
		val = params[idx].divi / (per / 100);
		
		if ((params[idx].min <= val) && (val <= params[idx].max)) {
			PRINT("TEXT, 775,(Y_%.2f-8),%.2f, RGB_BLACK, 000000, TRUE, Arial, 16, FALSE", per, per);
		}
		per += 0.25;
	}
	
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void calendar(INT32)
	引数：INT32    -
	機能：カレンダー
------------------------------------------------------------------------------*/
void calendar(INT32 idx)
{
	INT32 i, j;
	INT32 iDow;
	INT32 iRow;
	INT32 iDay;
	INT32 cnt;
	INT8 strRed  [11] = "RGB_RED,  ";
	INT8 strBlack[11] = "RGB_BLACK,";
	INT8 strBlue [11] = "RGB_BLUE, ";
	INT8 *p;
	INT8 strWeek[7][3] = {"日","月","火","水","木","金","土",};
	INT32 holy[5] = {HOLYDAY1, HOLYDAY2, HOLYDAY3, HOLYDAY4, HOLYDAY5,};
	INT8 fmt1[100+1] = "TEXT,(570+STEP*%d), (65+STEP*%d+0),%s, %s000000,TRUE,Arial,18,FALSE";
	INT8 fmt2[100+1] = "TEXT,(570+STEP*%d), (65+STEP*%d+0),%2d, %s000000,TRUE,Arial,18,FALSE";
	INT8 fmt3_1[100+1] = "TEXT,(570+STEP*%d), (65+STEP*%d+5),%+.1f, %s000000,TRUE,Arial,12,FALSE";
	INT8 fmt3_0[100+1] = "TEXT,(570+STEP*%d), (65+STEP*%d+5),%+.0f, %s000000,TRUE,Arial,12,FALSE";
	INT8 *pFmt;
	double ratio;
	
	switch (idx) {
	case N0000:
	case I1605:
	case L4689:
	case E5020:
	case S6460:
	case R6723:
	case M7011:
	case N7201:
	case T7203:
	case M7261:
	case H7267:
	case M8306:
	case R8308:
	case S8410:
	case N9432:
		pFmt = fmt3_1;
		break;
	case V2656:
	case S3778:
	case A5032:
	case C5253:
	case S6758:
	case K7494:
	case O7647:
	case P7956:
	case M8316:
	case M8411:
	case K9973:
	default:
		pFmt = fmt3_0;
		break;
	}
	
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  カレンダー");
	PRINT(":-------------------------------------------------------------------------------");
	PRINT("DEFINE, STEP, 30");
	
	i    = 0;
	iDow = 0;
	iRow = 0;
	iDay = 1;
	cnt  = MONTHBLANK;
	
	while (1) {
		switch (iDow) {
		case 0:  p = strRed;   break;
		case 6:  p = strBlue;  break;
		default: p = strBlack; break;
		}
		
		for (j = 0; j < 5; j++) {
			if (holy[j] == iDay) {p = strRed;}
		}
		
		if (iRow == 0) {
			PRINT(fmt1, iDow, iRow, strWeek[iDow], p);
		}
		else {
			if (cnt != 0) {
				PRINT(fmt1, iDow, iRow, "  ", p);
				cnt--;
			}
			else {
				if (iDay <= DAY) {
					if (isExist(idx, iDay, &ratio)) {
						if      (ratio > 0) {p = strRed;}
						else if (ratio < 0) {p = strBlue;}
						else                {p = strBlack;}
						PRINT(pFmt, iDow, iRow, ratio, p);
					}
					else {
						PRINT(fmt2, iDow, iRow, iDay, p);
					}
					iDay++;
				}
				else {
					PRINT(fmt1, iDow, iRow, "  ", p);
				}
			}
		}
		
		if ((iDow == 6) && (iDay > DAY)) {break;}
		
		i++;
		iDow = i % 7;
		iRow = i / 7;
	}
	
	PRINT("");
}

/*------------------------------------------------------------------------------
	書式：void etc(INT32)
	引数：INT32    -
	機能：その他
------------------------------------------------------------------------------*/
void etc(INT32 idx)
{
	PRINT(":-------------------------------------------------------------------------------");
	PRINT(":  その他");
	PRINT(":-------------------------------------------------------------------------------");
	
	switch (idx) {
	case N0000:
		break;
	case I1605:
//		PRINT("TEXT,10,10,+250,RGB_RED,000000,TRUE,Arial,30,FALSE");
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,+8, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+9, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,-3, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		break;
	case V2656:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		break;
	case S3778:
//		PRINT("TEXT,10,10,-2000,RGB_BLUE,000000,TRUE,Arial,30,FALSE");
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,+3, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case L4689:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-3, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case E5020:
//		PRINT("TEXT,10,10,+50,RGB_RED,000000,TRUE,Arial,30,FALSE");
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT,10,10,+25,RGB_RED,000000,TRUE,Arial,30,FALSE");
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,+3, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		break;
	case A5032:
//		PRINT("TEXT,10,10,-500,RGB_BLUE,000000,TRUE,Arial,30,FALSE");
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,-3, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-4, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,-5, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case C5253:
//		PRINT("TEXT,10,10,-400,RGB_BLUE,000000,TRUE,Arial,30,FALSE");
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,-3, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-4, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,-5, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT,10,10,-100,RGB_BLUE,000000,TRUE,Arial,30,FALSE");
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,-6, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case S6460:
//		PRINT("TEXT,10,10,+100,RGB_RED,000000,TRUE,Arial,30,FALSE");
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT,10,10,+200,RGB_RED,000000,TRUE,Arial,30,FALSE");
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+2, RGB_RED, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+3, RGB_RED, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+4, RGB_RED, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case R6723:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT,10,10,+100,RGB_RED,000000,TRUE,Arial,30,FALSE");
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		break;
	case S6758:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case M7011:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case N7201:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		break;
	case T7203:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case M7261:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-3, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case H7267:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,-3, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		break;
	case K7494:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT,10,10,-90,RGB_BLUE,000000,TRUE,Arial,30,FALSE");
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case O7647:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-3, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,-4, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-5, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case P7956:
//		PRINT("TEXT,10,10,-100,RGB_BLUE,000000,TRUE,Arial,30,FALSE");
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+3, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+4, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case M8306:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+3, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		break;
	case R8308:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case M8316:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+3, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+4, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,+5, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		break;
	case S8410:
//		PRINT("TEXT,10,10,-25,RGB_BLUE,000000,TRUE,Arial,30,FALSE");
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,-3, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-4, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		break;
	case M8411:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,+3, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,+4, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,+5, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		break;
	case N9432:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT,10,10,-10,RGB_BLUE,000000,TRUE,Arial,30,FALSE");
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,+2, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-1, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,-2, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,+1, RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		break;
	case K9973:
//		PRINT("TEXT, X1+(W* 5)/(DAYS+1), Y_WEEKEND,-11, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*10)/(DAYS+1), Y_WEEKEND,-12, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*15)/(DAYS+1), Y_WEEKEND,-13, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
//		PRINT("TEXT, X1+(W*20)/(DAYS+1), Y_WEEKEND,-14, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		
		PRINT("TEXT, X1+(W* 2)/(DAYS+1), Y_WEEKEND,-15, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W* 6)/(DAYS+1), Y_WEEKEND,-16, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*11)/(DAYS+1), Y_WEEKEND,-17, RGB_BLUE, 000000, TRUE, Arial, 16, FALSE");
		PRINT("TEXT, X1+(W*16)/(DAYS+1), Y_WEEKEND,+1,  RGB_RED,  000000, TRUE, Arial, 16, FALSE");
		break;
	default:
		break;
	}
}

/*------------------------------------------------------------------------------
	書式：BOOL isExist(INT32, INT32, double *)
	引数：INT32     -
	      INT32     -
	      double *  -
	戻値：BOOL      -
	機能：カレンダー
------------------------------------------------------------------------------*/
BOOL isExist(INT32 idx, INT32 day, double *pRatio)
{
	INT32 i;
	INT32 date;
	
	if (idx == N0000) {return FALSE;}
	
	date = 0x00000000 | (convDecToHex(YEAR)  << 16) |
						(convDecToHex(MONTH) <<  8) |
						(convDecToHex(day)   <<  0);
	
	for (i = 0; i < CNT; i++) {
		if (pField[i].date == date) {
			*pRatio = pField[i].ratio;
			return TRUE;
		}
	}
	
	return FALSE;
}

/*------------------------------------------------------------------------------
	書式：INT32 convDecToHex(INT32)
	引数：INT32    -
	戻値：INT32    -
	機能：十進数を十六進に見せる
------------------------------------------------------------------------------*/
INT32 convDecToHex(INT32 dec)
{
	INT32 hex;
	
	hex = 0x00000000;
	hex |= ((dec / 10) << 4);
	hex |= ((dec % 10) << 0);
	
	return hex;
}

/*------------------------------------------------------------------------------
	書式：void fprintf_crlf(char *pStr, ...)
	引数：char *  -
	      ...     -
	機能：出力
------------------------------------------------------------------------------*/
void fprintf_crlf(char *pStr, ...)
{
	va_list args;
	
	va_start(args, pStr);
	
	vfprintf(fp, pStr, args);
	fprintf(fp, "\r\n");
	
	va_end(args); 
}
